<?php

DEFINE('DEBUG', false);

$config = array();

$defaults = array(
	'node'=> array(
		'base' => 'nodejs',
		'nodes' => 'nodes',
		'version' => '0.10.32',
		'arch' => 'linux-x64'
	),
	'scripts'=>array()
);

function config_load($key, $default){
	global $config;
	if(file_exists("config_$key.json")){
		$config[$key] = json_decode(file_get_contents("config_$key.json"), true);
	}
	else{
		$config[$key] = $default;
	}
}

function config_save($key)
{
	global $config;
	file_put_contents("config_$key.json", json_encode($config[$key]));
}

config_load('node', $defaults['node']);
config_load('scripts', array());

DEFINE('NODE_BIN_DIR', $config['node']['base'].'/bin');
DEFINE('NODE_NAME', 'node-v'.$config['node']['version'].'-'.$config['node']['arch']);
DEFINE('NODE_ARCHIVE', NODE_NAME.'.tar.gz');
DEFINE('NODE_ARCHIVE_URL', 'https://nodejs.org/download/release/v'.$config['node']['version'].'/'.NODE_ARCHIVE);
DEFINE('NODE_PATH', getcwd().'/'.NODE_BIN_DIR);
DEFINE('NODE_DEFINES', 'PATH='.NODE_PATH.':$PATH HOME='.getcwd().'/'.$config['node']['base']);

?>
