<?php
header("Content-Type: text/html; charset=utf-8");
include 'config.php';
include 'lib/tools.php';
function is_exec_available() {
	if ( $safe_mode = ini_get( 'safe_mode' ) && strtolower( $safe_mode ) != 'off' )
		return false;
	if ( in_array( 'exec', array_map( 'trim', explode( ',', ini_get( 'disable_functions' ) ) ) ) )
		return false;
	return true;
}
ob_start();
?>

<!doctype html>
<html>
<head>
    <title>node.js installer</title>
    <link rel="stylesheet" type="text/css" href="css/foundation.min.css">
    <link rel="stylesheet" type="text/css" href="css/normalize.css">
    <link rel="stylesheet" type="text/css" href="css/hostdream.css">
    <script type="text/javascript" src="js/vendor/jquery.js"></script>
    <script type="text/javascript" src="js/vendor/modernizr.js"></script>
    <script type="text/javascript" src="js/foundation.min.js"></script>
    <script type="text/javascript">
        $(document).ready(function(){$(document).foundation();});
    </script>
</head>
<body>
    <nav class="top-bar" data-topbar role="navigation">
        <ul class="title-area">
            <li class="name">
                <h1><a href="#">node.js Manager Installation</a></h1>
            </li>
        </ul>
    </nav>
<?php
	$stage = 0;
	if(isset($_GET['stage'])){
		$stage = intval($_GET['stage']);
	}

	if(!is_exec_available()){
		alert('alert', '"exec" ist in Ihrem Webspace deaktiviert oder PHP läuft im "save_mode". Die Installation kann nicht durchgeführt werden. Wenden Sie sich an den Support.');
	}

	if($stage == 0 AND is_exec_available())
	{
	echo "<br><br>";
		$node_dl = file_get_contents('https://nodejs.org/download/release/latest/');
		$node_version = array();
		$vfound = preg_match('/<a href="(.*?)">node-v(.*?)-linux-arm64.tar.gz<\\/a>/', $node_dl, $node_version);
		if($vfound !== FALSE && $vfound > 0){
			$config['node']['version'] = $node_version[2];
		}
		?>
			<form action="?stage=1" method="POST">
				<div class="row">
					<label>Basis-Verzeichnis für node.js
						<input name="base" type="text" placeholder="<?php echo $config['node']['base'] ?>" required/>
					</label>
				</div>
				<div class="row">
					<label>node.js Architektur <small>(linux-x86, linux-x64, darwin-x86, darwin-x64, sunos-x86, sunos-x64)</small>
						<input name="arch" type="text" placeholder="<?php echo $config['node']['arch'] ?>" required/>
					</label>
				</div>
				<div class="row">
					<label>node.js Version <small>(current version: <?php echo $config['node']['version'] ?>)</small>
						<input name="version" type="text" placeholder="<?php echo $config['node']['version'] ?>" required/>
					</label>
				</div>
				<div class="row">
					<label>Installationsverzeichnis für node.js Skripte
						<input name="nodes" type="text" placeholder="<?php echo $config['node']['nodes'] ?>" required/>
					</label>
				</div>
				<div class="row">
					<div class="large-12 columns">
						<input class="button" name="save" type="submit" value="Speichern und weiter"/>
					</div>
				</div>
			</form>
		<?php
	}
	else if ($stage == 1)
	{
		if(
			isset($_POST['save']) &&
			isset($_POST['base']) &&
			isset($_POST['arch']) &&
			isset($_POST['version']) &&
			isset($_POST['nodes'])
		){
			$base = trim($_POST['base']);
			$arch = trim($_POST['arch']);
			$version = trim($_POST['version']);
			$nodes = trim($_POST['nodes']);
			$config['node']['base'] = $base;
			$config['node']['arch'] = $arch;
			$config['node']['version'] = $version;
			$config['node']['nodes'] = $nodes;

			config_save('node');
			alert('success', 'Eingabe wurde gespeichert. Sie werden zum nächsten Schritt weiter geleitet.');

			header('location: ?stage=2');
		}
		else{
			alert('alert', 'Eine Eingabe war nicht korrekt, bitte navigieren Sie zurück und überprüfen Sie Ihre Eingabe.');
		}
	}
	else if($stage == 2){
		$result = cmd(NODE_DEFINES.' wget -O '.NODE_ARCHIVE.' '.NODE_ARCHIVE_URL);
		if($result[1] == 0){
			alert('success', 'node.js v'.$config['node']['version'].' für '.$config['node']['arch'] . ' wurde heruntergeladen.<br>Klicken Sie auf "Weiter", um die Intsallation von node.js durchzuführen.');
			echo '<a class="button large-12 columns" href="?stage=3">Weiter</a>';
		}
		else{alert('alert', 'Beim Download trat ein Fehler auf: '.$result[1]);}
	}
	else if ($stage == 3)
	{
		cmd('mkdir ' . $config['node']['nodes']);
		$result = cmd(NODE_DEFINES.' tar xvzf '.NODE_ARCHIVE);
		if($result[1] < 3) alert('success', 'node.js wurde entpackt.');
		else{alert('alert', 'Fehler beim Entpacken der Dateien: '.$result[1]);}

		$result = cmd(NODE_DEFINES.' rm -f '.NODE_ARCHIVE);
		if($result[1] == 0) ;
		else{alert('alert', 'Fehler beim Löschen des Archives: '.$result[1]);}

		$result = cmd(NODE_DEFINES.' rm -rf '.$config['node']['base']);
		if($result[1] == 0) ;
		else{alert('alert', 'Fehler beim Löschen der ursprünglichen Installation: '.$result[1]);}

		$result = cmd(NODE_DEFINES.' mv '.NODE_NAME.' '.$config['node']['base']);
		if($result[1] == 0) alert('success', 'Das System wurde bereinigt.');
		else{alert('alert', 'Fehler beim Anpassen des Basispfades: '.$result[1]);}

		alert('success', 'node.js wurde erfolgreich installiert und kann nun verwendet werden.');

		echo '<a class="button large-12 columns" href="index.php">Zur Verwaltung</a>';
	}
?>
</body>
</html>
<?php
	ob_end_flush();
?>
