var WaitOverlay = function(options){
	this.options = options || {};
	for(var o in this._defaults){
		this.options[o] = this.options[o] || this._defaults[o];
	}

	this.obj = $('<div/>');
	this.obj.css({
		display: 'none',
		position: 'absolute',
		left: 0,
		right: 0,
		top: 0,
		bottom: 0,
		opacity: 0,
		background: this.options.background
	});

	this.calls = 0;
	$('body').append(this.obj);
}

WaitOverlay.prototype._defaults = {
	opacity: 0.8,
	background: '#000000'
}
WaitOverlay.prototype.show = function(){
	if(this.calls == 0){
		$('body').css('overflow', 'hidden');
		this.obj.css({
			display: 'block'
		});
		this.obj.fadeTo(300, this.options.opacity);
	}
	this.calls++;
}
WaitOverlay.prototype.hide = function(){
	this.calls--;
	var _this = this;
	if(this.calls == 0){
		this.obj.fadeOut(300, function(){
			_this.obj.css('display', 'none');
		});
		$('body').css('overflow', 'auto');
	}
}